#include <string.h>

#include "util.hpp"

// create a string that contains only the filename portion of a full path
// user is responsible for deleting
char* createFileName_from_fullPath (const char* fullPath)
{
	int length = strlen (fullPath);
	int index = length - 1;
	bool looping = true;

	if (index < 0)
	{
		looping = false;
	}
	else if ((fullPath [index] == '\\') ||
					 (fullPath [index] == '/'))
	{
		looping = false;
	}


	while (looping)
	{

		-- index;

		if (index < 0)
		{
			looping = false;
		}
		else if ((fullPath [index] == '\\') ||
						 (fullPath [index] == '/'))
		{
			looping = false;
		}

	}
	++ index;


	// allocate return string
	char* result = new char [length - index + 1];
	int resultIndex = 0;

	while (index < length)
	{
		result [resultIndex] = fullPath [index];
		++ resultIndex;
		++ index;
	}
	result [resultIndex] = '\0';


	return result;
}


static char* dateMap [] = {
"Jan", "January",
"Feb", "February",
"Mar", "March",
"Apr", "April",
"May", "May",
"Jun", "June",
"Jul", "July",
"Aug", "August",
"Sep", "September",
"Oct", "October",
"Nov", "November",
"Dec", "December"
};

//
// convert mmmddyyyy to written
// user is responsible for deleting string
//
char* date_mmmddyyyy_toWritten (const char* date)
{
	char* result = new char [32];

	int index = 0;
	bool found = false;
	while ((index < (12 * 2)) &&
				 (!found))
	{
		if (strncmp (date, dateMap [index], 3) == 0)
		{
			found = true;
		}
		else
		{
			index += 2;
		}
	}

	strcpy (result, dateMap [index + 1]);
	strcat (result, " ");
	strncat (result, &(date [4]), 2);
	strcat (result, ", ");
	strncat (result, &(date [7]), 4);

	return result;
}
